#!/usr/bin/env python3
""" Statistical Language Processing (SNLP), Assignment 3
    See <https://snlp2020.github.io/a3/> for detailed instructions.

    <Please insert your name and the honor code here.>
"""


def read_data(filename, shuffle=True):
    """ Read the tab-separated training or test files.

    Parameters:
    -----------
    filename:  The name of the file to read.
    shuffle:   If true, the instances should be shuffled (make sure
               not scramble correspondences between the predictors and
               the outcomes).

    Returns: (a tuple)
    -----------
    words:      The list of words in the input file.
    languages:  The corresponding language codes.
    """
    ### Exercise 3.1

def get_bigrams(word, bow='<', eow='>'):
    """ Calculate and return the character bigrams of a word.

    Parameters:
    -----------
    word:      A sequence (word) to be processed.
    bow, eow:  Beginning- and end-of-word symbols to prepend/append.
               (defaults are fine, since they do not occur in the data)

    Returns:
    -----------
    bigrams:   A sequence of (character) bigrams.
    """
    ### Exercise 3.1

class BigramEncoder:
    def __init__(self):
        """Initialize any data/state here if you need it. 

        You can extend the API (adding arguments as needed).
        """
        ### Exercise 3.1

    def fit(self, words):
        """ Calculate/update necessary bookkeeping data.

        You are free to chose your implementation. However, what you
        typically need is to build/update a mapping between bigrams
        and unique integers representing each bigram, so that for each
        word in "transform()" below, you can map a bigram to an
        integer (index) value.
        """
        ### Exercise 3.1

    def transform(self, words):
        """Transform the given word according to the already fitted encoder.
    
        Parameters:
        -----------
        words:     A list of words (a sequence of sequences/strings)

        Returns:
        -----------
        encoded_words: A numpy or scipy sparse array of shape (n, m)
                       where 'n' is the number of words, 'm' is the
                       number of unique bigrams in the data used for
                       fitting the encoder. Use of sparse matrices is
                       strongly recommended.
        """
        ### Exercise 3.1

    def inv_transform(self, bigram_id, one_hot=False):
        """Return the bigram given its integer or one-hot representation.

        Parameters:
        -----------
        bigram_id: The integer ID/representation of a bigram.
        one-hot:   If True, bigram_id is a one-hot representation where
                   only the element corresponding to the bigram index is 1.

        Returns:
        -----------
        The bigram or None if bigram is unknown.
        """
        ### Useful for exercise 3.4

def cross_validate(model, words, languages, encoder=None, k=5, verbose=False):
    """Select and return the best model using cross-validation.

    The parameters and the range should be chosen based on the 'model'
    parameter. At a minimum you should tune the parameter 'C' (inverse
    of the regularization strength) for logistic regression, and
    'alpha' (Laplace smoothing factor) for naive Bayes. You may, but
    not required to, tune any other hyperparameter that may be important.

    The best model should be selected based 'macro averaged' F1 score.

    Parameters:
    -----------
    model:  'nb' for 'naive Bayes' or 'lr' for logistic regression.
            You are support other classifiers here.
    words:     The list of words for training/validation.
    languages: The corresponding labels (languages).
    encoder:   If None, you should fit an encoder object here.
               This is included in case you want to tune some aspects
               of the encoder as well. If not, you should just pass an
               encoder fitted for all models you tune.
    k:         The number of folds
    verbose:   If true, print out state/results of the tuning process.

    Returns:
    -----------
    A tuple with a classifier and an encoder object
    """
    ### Exercise 3.2

def evaluate(models, encoder, words, languages):
    """Print out evaluation metrics.
    
    This function should print out evaluation metrics / analyses
    described in the assignment sheet (Exercise 3.3).


    Parameters:
    -----------
    models:    A sequence of classifier objects.
    encoder:   The feature encoder (optionally as sequence if you use
               different encoders for different classifiers).
               We assume that you have a common encoder for all models
               you evaluate. If you use different encoders, feel free
               to allow a sequence here.
    words:     Test words.
    languages: The corresponding labels (languages).

    Returns:
    -----------
    None
    """
    ### Exercise 3.3

def print_predictors(model, encoder, language, model_type, n=10):
    """Print out best predictors for the given language.
    
    This predictors (bigrams) that are most useful for the given
    language.

    Parameters:
    -----------
    model:     A classifier object
    encoder:   The feature encoder (optionally as sequence if you use
               different encoders for different classifiers).
    type_:     A string describing the classifier, e.g., 'nb', or 'lr'.
    language:  The 3-letter language code.
    n:         Number of 'top' predictors to print.

    Returns:
    -----------
    None
    """
    ### Exercise 3.4

if  __name__ == '__main__':
    ### not required
